<script setup lang="ts">
import { ref, reactive, watch, defineProps } from "vue";
import { useQuasar } from "quasar";
import http from "@/plugins/http";
import config from "@/app.config";
import type { QTableProps } from "quasar";
import DialogHeader from "@/components/DialogHeader.vue";
import type {
  DataOption,
  FormPositionSelectDialog,
  FormPositionSelectRef,
  OptionType,
  OptionLevel,
  OptionExecutive,
} from "@/modules/01_metadataNew/interface/request/position/index";
import { useCounterMixin } from "@/stores/mixin";
const executiveOpsMain = ref<DataOption[]>([]);
const levelOps = ref<DataOption[]>([]);
const levelOpsMain = ref<DataOption[]>([]);
const typeOps = ref<DataOption[]>([]);
const typeOpsMain = ref<DataOption[]>([]);
const dataLevel = ref<any>();
const executiveOps = ref<DataOption[]>([]);
const formPositionSelect = reactive<FormPositionSelectDialog>({
  positionId: "",
  positionName: "",
  positionField: "",
  positionType: "",
  positionLevel: "",
  positionExecutive: "",
  positionExecutiveField: "",
  positionArea: "",
});
const $q = useQuasar();
const isSpecial = ref<boolean>(false);
const props = defineProps({
  getData: Function,
});
const { dialogConfirm, showLoader, success, hideLoader, messageError } =
  useCounterMixin();

const isReadonly = ref<boolean>(false); // อ่านได้อย่างเดียว
const modal = defineModel<boolean>("addPosition", { required: true });
const formData = defineModel<any>("formData", { required: true });
const editCheck = defineModel<boolean>("editCheck", { required: true });

const positionNameRef = ref<Object | null>(null);
const positionFieldRef = ref<Object | null>(null);
const positionTypeRef = ref<Object | null>(null);
const positionLevelRef = ref<Object | null>(null);
const positionExecutiveRef = ref<Object | null>(null);
const positionExecutiveFieldRef = ref<Object | null>(null);
const positionAreaRef = ref<Object | null>(null);

const objectPositionSelectRef: FormPositionSelectRef = {
  positionName: positionNameRef,
  positionField: positionFieldRef,
  positionType: positionTypeRef,
  positionLevel: positionLevelRef,
  positionExecutive: positionExecutiveRef,
  positionExecutiveField: positionExecutiveFieldRef,
  positionArea: positionAreaRef,
};

/** ฟังก์ชั่นตรวจสอบความถูกต้องของข้อมูลในฟอร์ม */
function validateFormPositionEdit() {
  const hasError = [];
  for (const key in objectPositionSelectRef) {
    if (Object.prototype.hasOwnProperty.call(objectPositionSelectRef, key)) {
      const property = objectPositionSelectRef[key];
      if (property.value && typeof property.value.validate === "function") {
        const isValid = property.value.validate();
        hasError.push(isValid);
      }
    }
  }
  if (hasError.every((result) => result === true)) {
    if (editCheck.value == true) {
      saveSelectEdit();
    } else {
      onSubmitSelectEdit();
    }
  }
}

/** ฟังชั่น บันทึก */
function saveSelectEdit() {
  console.log(formPositionSelect.positionExecutive);
  console.log(formPositionSelect.positionArea);
  dialogConfirm(
    $q,
    async () => {
      showLoader();
      const body = {
        posDictName: formPositionSelect.positionName,
        posDictField: formPositionSelect.positionField, //สายงาน
        posTypeId: formPositionSelect.positionType, //*ประเภทตำแหน่ง
        posLevelId: formPositionSelect.positionLevel, //*ระดับตำแหน่ง
        posExecutiveId: formPositionSelect.positionExecutive, //ตำแหน่งทางการบริหาร
        posDictExecutiveField: formPositionSelect.positionExecutiveField, //ด้านทางการบริหาร
        posDictArea: formPositionSelect.positionArea, //ด้าน/สาขา
        isSpecial: isSpecial.value,
      };
      await http
        .put(config.API.orgPosPositionById(formPositionSelect.positionId), body)
        .then(() => {
          success($q, "เพิ่มข้อมูลสำเร็จ");
          clearFormPositionSelect();
          modal.value = false;
          editCheck.value = false;
          props.getData?.();
        })
        .catch((err) => {
          messageError($q, err);
        })
        .finally(() => {
          hideLoader();
        });
    },
    "ยืนยันการเพิ่มตำแหน่ง",
    "ต้องการยืนยันการเพิ่มตำแหน่งนี้ใช่หรือไม่?"
  );
}
/** ฟังชั่น บันทึก */
function onSubmitSelectEdit() {
  dialogConfirm(
    $q,
    async () => {
      showLoader();
      const body = {
        posDictName: formPositionSelect.positionName,
        posDictField: formPositionSelect.positionField, //สายงาน
        posTypeId: formPositionSelect.positionType, //*ประเภทตำแหน่ง
        posLevelId: formPositionSelect.positionLevel, //*ระดับตำแหน่ง
        posExecutiveId: formPositionSelect.positionExecutive,
        posDictExecutiveField: formPositionSelect.positionExecutiveField, //ด้านทางการบริหาร
        posDictArea: formPositionSelect.positionArea, //ด้าน/สาขา
        isSpecial: isSpecial.value,
      };
      await http
        .post(config.API.orgPosPosition, body)
        .then(() => {
          success($q, "เพิ่มข้อมูลสำเร็จ");
          clearFormPositionSelect();
          modal.value = false;
          editCheck.value = false;
        })
        .catch((err) => {
          messageError($q, err);
        })
        .finally(() => {
          hideLoader();
        });
    },
    "ยืนยันการเพิ่มตำแหน่ง",
    "ต้องการยืนยันการเพิ่มตำแหน่งนี้ใช่หรือไม่?"
  );
}

async function clearFormPositionSelect() {
  formPositionSelect.positionId = "";
  formPositionSelect.positionName = "";
  formPositionSelect.positionField = "";
  formPositionSelect.positionType = "";
  formPositionSelect.positionLevel = "";
  formPositionSelect.positionExecutive = "";
  formPositionSelect.positionExecutiveField = "";
  formPositionSelect.positionArea = "";
}

/**
 * ส่งค่า css ออกไปตามเงื่อนไข
 * @param val true/false
 */
function inputEdit(val: boolean) {
  return {
    "full-width cursor-pointer inputgreen ": val,
    "full-width cursor-pointer inputgreen": !val,
  };
}

/** function เรียกรายการประเภทตำแหน่ง */
async function fetchType() {
  showLoader();
  await http
    .get(config.API.orgPosType)
    .then((res) => {
      const data = res.data.result;
      dataLevel.value = data;
      typeOpsMain.value = data.map((e: OptionType) => ({
        id: e.id,
        name: e.posTypeName,
      }));
      typeOps.value = typeOpsMain.value;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/** function เรียกรายการตำแหน่งทางการบริหาร */
async function fetchExecutive() {
  showLoader();
  await http
    .get(config.API.orgPosExecutive)
    .then((res) => {
      executiveOpsMain.value = res.data.result.map((e: OptionExecutive) => ({
        id: e.id,
        name: e.posExecutiveName,
      }));
      executiveOps.value = executiveOpsMain.value;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

watch(
  () => modal.value,
  () => {
    if (modal.value == true) {
      fetchType();
      fetchExecutive();
      if (formData.value) {
        const dataList = formData.value;
        setTimeout(() => {
          updateSelectType(dataList.posTypeId);
        }, 1000);
        formPositionSelect.positionId = dataList.positionId;
        formPositionSelect.positionName = dataList.positionName;
        formPositionSelect.positionField = dataList.positionField;
        formPositionSelect.positionType = dataList.positionType;
        formPositionSelect.positionLevel = dataList.positionLevel;
        formPositionSelect.positionExecutive = dataList.positionExecutive;
        formPositionSelect.positionExecutiveField =
          dataList.positionExecutiveField;
        formPositionSelect.positionArea = dataList.positionArea;
        isSpecial.value = dataList.isSpecial;
      }
    }
  }
);

function updateSelectType(val: string) {
  const listLevel = dataLevel.value.find((e: any) => e.id === val);
  levelOpsMain.value = listLevel.posLevels.map((e: OptionLevel) => ({
    id: e.id,
    name: e.posLevelName,
  }));
  levelOps.value = levelOpsMain.value;
}

function close() {
  modal.value = false;
  editCheck.value = false;
}
</script>

<template>
  <q-dialog v-model="modal" persistent>
    <q-card style="min-width: 50vw">
      <form @submit.prevent="validateFormPositionEdit">
        <DialogHeader
          :tittle="`${editCheck ? 'แก้ไขข้อมูลตำแหน่ง' : 'เพิ่มข้อมูลตำแหน่ง'}`"
          :close="close"
        />
        <q-separator />

        <q-card-section>
          <div class="row q-col-gutter-sm col-12">
            <div class="col-12">
              <q-input
                ref="positionNameRef"
                v-model="formPositionSelect.positionName"
                :class="inputEdit(isReadonly)"
                dense
                outlined
                for="#positionName"
                label="ตำแหน่งในสายงาน"
                lazy-rules
                hide-bottom-space
                :rules="[(val) => !!val || `${'กรุณากรอกตำแหน่งในสายงาน'}`]"
              />
            </div>
            <div class="col-6">
              <q-input
                ref="positionAreaRef"
                v-model="formPositionSelect.positionArea"
                :class="inputEdit(isReadonly)"
                dense
                outlined
                for="#positionArea"
                label="ด้าน/สาขา"
                lazy-rules
                hide-bottom-space
              />
            </div>
            <div class="col-6">
              <q-input
                ref="positionFieldRef"
                v-model="formPositionSelect.positionField"
                :class="inputEdit(isReadonly)"
                dense
                outlined
                for="#positionField"
                label="สายงาน"
                lazy-rules
                hide-bottom-space
                :rules="[(val) => !!val || `${'กรุณากรอกสายงาน'}`]"
              />
            </div>
            <div class="col-6">
              <q-select
                ref="positionTypeRef"
                :class="inputEdit(isReadonly)"
                label="ประเภทตำแหน่ง"
                v-model="formPositionSelect.positionType"
                :options="typeOps"
                emit-value
                dense
                @update:model-value="updateSelectType"
                map-options
                outlined
                option-label="name"
                option-value="id"
                lazy-rules
                hide-bottom-space
                :rules="[(val) => !!val || `${'กรุณาเลือกประเภทตำแหน่ง'}`]"
              />
            </div>
            <div class="col-6">
              <q-select
                ref="positionLevelRef"
                :class="inputEdit(isReadonly)"
                label="ระดับตำแหน่ง"
                v-model="formPositionSelect.positionLevel"
                :disable="formPositionSelect.positionType === ''"
                :options="levelOps"
                emit-value
                dense
                map-options
                outlined
                option-label="name"
                option-value="id"
                lazy-rules
                hide-bottom-space
                :rules="[(val) => !!val || `${'กรุณาเลือกระดับตำแหน่ง'}`]"
              />
            </div>
            <div class="col-6">
              <q-select
                ref="positionExecutiveRef"
                :class="inputEdit(isReadonly)"
                label="ตำแหน่งทางการบริหาร"
                v-model="formPositionSelect.positionExecutive"
                :options="executiveOps"
                emit-value
                dense
                map-options
                outlined
                option-label="name"
                option-value="id"
                lazy-rules
                hide-bottom-space
                clearable
              />
            </div>
            <div class="col-6">
              <q-input
                ref="positionExecutiveFieldRef"
                v-model="formPositionSelect.positionExecutiveField"
                :class="inputEdit(isReadonly)"
                dense
                outlined
                for="#positionExecutiveField"
                label="ด้านทางการบริหาร"
                lazy-rules
                hide-bottom-space
              />
            </div>

            <div class="col-6 self-center">
              <q-checkbox size="md" v-model="isSpecial" label="เฉพาะสายงานที่กำหนด" />
            </div>
          </div>
        </q-card-section>
        <q-separator />
        <q-card-actions align="right" class="bg-white text-teal">
          <q-btn type="submit" :label="`บันทึก`" color="public" />
        </q-card-actions>
      </form>
    </q-card>
  </q-dialog>
</template>
